package com.bcxin.runtime.domain.syncs.commands;

import com.bcxin.runtime.domain.syncs.dtos.FileItemRequestDto;
import lombok.Getter;

import java.util.Collection;

@Getter
public class CreateSyncFileCommand {
    private final String id;
    private final Collection<FileItemRequestDto> fileItems;

    public CreateSyncFileCommand(String id, Collection<FileItemRequestDto> fileItems) {
        this.id = id;
        this.fileItems = fileItems;
    }

    public static CreateSyncFileCommand create(String id,
                                               Collection<FileItemRequestDto> fileItems) {
        return new CreateSyncFileCommand(id, fileItems);
    }

    @Getter
    public static class CreateSyncFileCommandResult
    {
        private final String id;
        private final Collection<FileItemResponse> fileItems;


        public CreateSyncFileCommandResult(String id, Collection<FileItemResponse> fileItems) {
            this.id = id;
            this.fileItems = fileItems;
        }

        public static CreateSyncFileCommand.CreateSyncFileCommandResult create(String id, Collection<FileItemResponse> fileItems) {
            return new CreateSyncFileCommandResult(id, fileItems);
        }
    }

    @Getter
    public static class FileItemResponse {
        private final FileItemRequestDto request;
        private final boolean isSuccess;
        private final String message;

        public FileItemResponse(FileItemRequestDto request, boolean isSuccess, String message) {
            this.request = request;
            this.isSuccess = isSuccess;
            this.message = message;
        }

        public static FileItemResponse create(FileItemRequestDto request,
                                              boolean isSuccess, String message) {
            return new FileItemResponse(request, isSuccess, message);
        }
    }
}
